#ifndef SQLSTATEMENTSFEATURE_H_
#define SQLSTATEMENTSFEATURE_H_

#include "dbFeature.h"
#include "iopccommon/metadataHolder.h"
#include <vector>

namespace iopc {

class SqlStatementsFeature : public DbFeature
{
private:
	static std::string featureName;
public:
	virtual const std::string& getNameInst() {
		return getName();
	}
	
	static const std::string& getName() {
		return featureName;
	}
	
	virtual std::string getCreateTableStatement(const MetadataHolder& tableMeta, const std::vector<const MetadataHolder*>& columns, const MetadataHolder& createMeta = MetadataHolder::emptyMeta) =0;
	virtual std::string getDropTableStatement(const MetadataHolder& tableMeta, const MetadataHolder& dropmeta = MetadataHolder::emptyMeta) =0;
	virtual std::string getInsertStatement(const MetadataHolder& tableMeta, const std::vector<const MetadataHolder*>& inColumns, const MetadataHolder& insertMeta = MetadataHolder::emptyMeta) =0;
	virtual std::string getUpdateStatement(const MetadataHolder& tableMeta, const std::vector<const MetadataHolder*>& inColumns, const MetadataHolder& updateMeta = MetadataHolder::emptyMeta) =0;
	virtual std::string getDeleteStatement(const MetadataHolder& tableMeta, const MetadataHolder& deleteMeta = MetadataHolder::emptyMeta) =0;
	virtual std::string getSelectStatement(const std::vector<const MetadataHolder*>& tables, const std::vector<const MetadataHolder*>& outColumns, const MetadataHolder& selectMeta = MetadataHolder::emptyMeta) =0;
	virtual std::string getCreateViewStatement(const MetadataHolder& meta, const MetadataHolder& createMeta = MetadataHolder::emptyMeta) =0;
	virtual std::string getDropViewStatement(const MetadataHolder& meta, const MetadataHolder& dropMeta = MetadataHolder::emptyMeta) =0;
	virtual std::vector<std::string> getIndexes(const MetadataHolder& tableMeta, const std::vector<const MetadataHolder*>& columns) =0;	
};


}

#endif /*SQLSTATEMENTSFEATURE_H_*/
