#ifndef OBJECTSTATEMENTSFEATURE_H_
#define OBJECTSTATEMENTSFEATURE_H_

#include "iopcdb/dbFeature.h"
#include "iopccommon/metadataHolder.h"
#include "../types/dbType.h"
#include "iopccommon/rwLock.h"
#include "../types/objectMappingStrategy.h"
#include <vector>

namespace iopc {

class Type;

class ObjectStatementsFeature : public DbFeature
{
private:
	static std::string featureName;
public:
	virtual const std::string& getNameInst() {
		return getName();
	}
	
	static const std::string& getName() {
		return featureName;
	}
	
	// interface
	virtual std::string getSelectFromClassViewStatement(ObjectMappingStrategy& currentStrategy, const MetadataHolder& attributes = MetadataHolder::emptyMeta, bool useCache = true) =0;
	virtual std::string getSelectFromClassTableStatement(ObjectMappingStrategy& currentStrategy, const MetadataHolder& attributes = MetadataHolder::emptyMeta, bool useCache = true) =0;
	virtual std::string getInsertStatement(ObjectMappingStrategy& currentStrategy, const MetadataHolder& attributes = MetadataHolder::emptyMeta, bool useCache = true) =0;
	virtual std::string getUpdateStatement(ObjectMappingStrategy& currentStrategy, const MetadataHolder& attributes = MetadataHolder::emptyMeta, bool useCache = true) =0;
//	virtual std::string getUpdateStatement(ObjectMappingStrategy& currentStrategy, const ObjectMappingStrategy::MappedAttributesList& updateCols, const MetadataHolder& attributes = MetadataHolder::emptyMeta, bool useCache = true) =0;
	virtual std::string getDeleteStatement(ObjectMappingStrategy& currentStrategy, const MetadataHolder& attributes = MetadataHolder::emptyMeta, bool useCache = true) =0;
	virtual bool validate(ObjectMappingStrategy& currentStrategy, std::string& msg) =0;
};


}




#endif /*OBJECTSTATEMENTSFEATURE_H_*/
