#include "freeQuery.h"
#include "iopcmeta/type.h"
#include "types/dbTypeManager.h"
#include "iopcdb/driver.h"
#include "db/mappingStatementsFeature.h"

using namespace iopc;
using namespace std;

string FreeQuery::getSql(Driver& drv, const Type& type) const
{
	string substituted = substituteQuery(query, type);
	
	DbType& dbType = DbTypeManager::getDbType(type);
	MappingStatementsFeature& msf = drv.getFeature<MappingStatementsFeature>();
	MetadataHolder attributes;
	attributes["db.query.from"].setStringValue(substituted);
	if (prefix != "") {
		attributes["db.query.colPrefix"].setStringValue(prefix);
	}
	attributes["db.query.useViewCols"].setBoolValue(useViewColumns);
	
	return msf.getQueryStatement(dbType, attributes);
}

Query* FreeQuery::clone() const
{
	return new FreeQuery(*this);
}
