#ifndef MAPPINGSTRATEGY_H_
#define MAPPINGSTRATEGY_H_

#include "../oidObject.h"
namespace iopc {

class Connection;
class Cursor;
class DatabaseObject;
class KeyValues;
class Type;
class DbType;

class MappingStrategy
{
public:
	virtual void init() =0;
	virtual void postInit() =0;
	virtual void loadOne(Connection& conn, DatabaseObject* obj, const KeyValues& keyVals, bool wait, bool lock) =0;
	virtual OidObject* viewLoadAll(Connection& conn, const OidType& oid, bool wait, bool lock) =0;
	virtual void updateOne(Connection& conn, DatabaseObject& obj) =0;
	virtual void deleteOne(Connection& conn, const OidType& oid) =0;
	virtual void deleteOne(Connection& conn, const KeyValues& keyVals) =0;
	virtual void insertOne(Connection& conn, DatabaseObject& obj) =0;
	virtual DbType& getDbType() const =0;
	virtual const Type& getType() const =0;

	virtual ~MappingStrategy() {};
protected:

	void mapKeyAttributes(Cursor* cur, int startIndex, DatabaseObject& obj);
	void mapKeyAttributes(Cursor* cur, int startIndex, const KeyValues& keyVals);
	void mapKeyAttributes(Cursor* cur, int startIndex, const OidType& oid);
};

}

#endif /*MAPPINGSTRATEGY_H_*/
