#ifndef FAKEOBJECT_H_
#define FAKEOBJECT_H_

#include "iopclib/databaseObject.h"
//#include "fakeType.h"
#include "iopccommon/trace.h"
#include "iopcmeta/enhancedNumber.h"
#include "iopcmeta/enhancedString.h"
#include "iopcmeta/type.h"

//#define IOPC_SUPPORT(name)

class FakeObject : public iopc::DatabaseObject
{
public:
	iopc::EInt attrInt;
	iopc::EString attrString;
	iopc::EDouble attrDouble;

	static void iopcInit(iopc::Type& t) {
		iopc::LogWriter::logInfo("static IOPC_INIT_FAKE_OBJECT");
		
		t["db.table"] = "faketypetable";
		//t["db.mapping.type"] = "vertical";
		t["db.mapping.oidmanaged"] = false;
		t.getAttribute("attrInt")["db.column"] = "colInt";
		t.getAttribute("attrDouble")["db.column"] = "colDouble";
		t.getAttribute("attrString")["db.column"] = "colString";
		t.getAttribute("attrString")["db.type.length"] = 200;
		t.getAttribute("attrInt")["db.primaryKey"].setBoolValue(true);
		t.getAttribute("attrString")["db.primaryKey"].setBoolValue(true);
	}

public:
	//static const iopc::DbType& getType();
	
	void test() {
		iopc::LogWriter::logInfo("test(): DbPtrTest");
		attrInt = 3;
		attrDouble = 2.6;
		attrString = "Ahoj lidi";
	}

	friend class iopc::TypeDesc<FakeObject>;
};

#endif /*FAKEOBJECT_H_*/
