#include <iostream>
#include <ostream>
#include <istream>
#include <fstream>

#include "iopccommon/trace.h"
#include "tests/oracle10gConnectionTest.h"
#include "iopcdb/database.h"
#include "iopcdb/connection.h"
#include "iopcdb/driverManager.h"

using namespace iopc;
using namespace std;

Oracle10gConnectionTest::Oracle10gConnectionTest(const std::string& testName)
 : TestCase(testName)
{

}

Oracle10gConnectionTest::~Oracle10gConnectionTest()
{
}


bool Oracle10gConnectionTest::doTest()
{
	Database* db = NULL;
	Connection* conn = NULL;
	bool ret = true;
	try {
		logMsg("Simple Connect");
		db = DriverManager::getDriver("IopcOracle10g").getDatabase(DBNAME);
		conn = db->getConnection(CONNSTR);
		try {
			conn->open();
			if (!conn->isOpened()) {
				ret = false;
			}
			conn->close();
		} catch (std::exception& e) {
			LogWriter::logError(e.what());
			ret = false;
		}
		db->returnConnection(conn);

		logMsg("Not all connections will be returned");
		conn = db->getConnection(CONNSTR);
		conn = db->getConnection(CONNSTR);
		try {
			conn->open();
		} catch (std::exception& e) {
			LogWriter::logError(e.what());
			ret = false;
		}

	} catch (...) {
		ret = false;
	}

	logMsg("Deleting DB..");
	try {
		if (db) DriverManager::getDriver("IopcOracle10g").returnDatabase(db);
	} catch (...) {
		ret = false;
	}
	return ret;
}

static Oracle10gConnectionTest oracle10gConnectionTestInstance("Oracle10g - connection");
